
/*
 *  Ump - Unnamed Math Program
 *  Copyright (c) 2004-2006 by Mattias Hultgren <mattias_hultgren@tele2.se>
 *
 *  See main.cpp
 */

#include <stdio.h>
#include <gtk/gtk.h>
#include <string>
#include <sstream>
#include <sys/time.h>
#include "ump_picturewin.h"
#include "main.h"
#include "picture2gtk.h"
#include "math2.h"
#include "vartypes.h"
#include "string.h"

#include <iostream>

GtkWidget *picturewin = 0, *picwin_status, *picwin_combo_trace, *picwin_combo_action,
          *picwin_label_trace, *picturewin_vbox, *picturewin_menu;
guint pic_statusid;
picture2gtk picbild;
math::Picture picbild2;
Format stdformat;
Matrix trace_matrix;

timeval action_combo_changed;

graph_settings act_settings;

int32 old_tx, old_ty;
int old_best_match_i = -1;
guchar *picwin_rowbuffer = 0, *picwin_colbuffer = 0;
int picwin_rowbuffer_len = 0, picwin_colbuffer_len = 0;

bool picwin_first_click_done = false;

enum LeftClickAction { LeftClickAction_Zoom, LeftClickAction_FindRoot, LeftClickAction_FindMaximumMinimum,
                       LeftClickAction_FindIntersection, LeftClickAction_CalcDerivate, LeftClickAction_CalcIntegral,
                       LeftClickAction_CalcLength };

bool picturewin_action_dont_show_dialog = false;


void picwin_mousedown( const picture2gtk *src, int32 x, int32 y, int32 button );

int conv_combobox_index_to_function_index(int index)
{
	int i;

	if(index < 2)
		return -1;

	index -= 2;
	for(i=0;i<10;i++)
	{
		if(act_settings.func[i].show_this)
		{
			if(index == 0)
				return i;
			index--;
		}
	}

	return -1;
}
int conv_function_index_to_combobox_index(int index)
{
	int i,ret;
	ret = 0;

	if( index < 0  ||  index >= 10 )
		return -1;

	if(!act_settings.func[index].show_this)
		return -1;

	for(i=0;i<10;i++)
	{
		if(act_settings.func[i].show_this)
		{
			if(i == index)
				return ret+2;
			ret++;
		}
	}

	return -1; // this line should be unreachable...
}

int picwin_reload_combos(int combo_action_entries)
{
	if(combo_action_entries != 0)
	{
		for(int i=0; i<7; i++ )
			gtk_combo_box_remove_text( GTK_COMBO_BOX(picwin_combo_action), 0 );
	}

	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Zoom") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Find root") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Find maximum/minimum") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Find intersection") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Calculate derivate") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Calculate integral") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_action), _("Calculate length") );

	gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), -1 );


	for(;combo_action_entries > 0;combo_action_entries--) // removing all entries
		gtk_combo_box_remove_text( GTK_COMBO_BOX(picwin_combo_trace), 0 );

	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_trace), _("Off") );
	gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_trace), _("Auto") );

	combo_action_entries = 2;
	if( act_settings.active_page == 0  ||  !act_settings.show_active_page_only )
	{
		char tmp_str[100];
		const char *trans = _("Locked on y%ld");

		for(int i=0;i<10;i++)
		{
			if( act_settings.func[i].show_this )
			{
				snprintf( tmp_str, 100, trans, i );

				gtk_combo_box_append_text( GTK_COMBO_BOX(picwin_combo_trace), tmp_str );
				combo_action_entries++;
			}
		}
	}

	gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), 0 );

	return combo_action_entries;
}

void place_marker(float x, float y, picture_h::colorrgb color)
{
	picbild2.pic.line( int32(x)-3, int32(y), int32(x)+3, int32(y), color );
	picbild2.pic.line( int32(x), int32(y)-3, int32(x), int32(y)+3, color );

	picbild.update_from( picbild2.pic );
}

void picwin_intersection_show(int32 x)
{
	GtkWidget *dialog,*label,*radiobutton,*align,*vbox;
	std::ostringstream ostr;
	std::string str;
	int second_function,nr;
	GtkWidget *radios[10];
	Complex tmp_value_x, tmp_value_y;
	math::CodeLine function;

	nr = 0;
	for(int i=0;i<10;i++)
	{
		if(act_settings.func[i].show_this)
			nr++;
	}
	if(nr < 2) // at least 2 functions has to be drawn
	{
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
		                                 GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE,
		             _("At least 2 functions must be drawn\nto be able to find an intersection") );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Find intersection") );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);

		return;
	}
	else if(nr > 2) // if it's more than 2, dialog must be shown and user should choose which...
	{
		dialog = gtk_dialog_new_with_buttons( _("Find intersection"), GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
		                                      GTK_STOCK_OK, GTK_RESPONSE_OK, NULL );

		align = gtk_alignment_new( 0.0, 0.0, 1.0, 1.0 );
		gtk_container_set_border_width( GTK_CONTAINER(align), 5 );
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), align, FALSE, FALSE, 0);

		vbox = gtk_vbox_new( FALSE, 3 );
		gtk_container_add( GTK_CONTAINER(align), vbox );

		label = gtk_label_new( _("Find intersection between") );
		gtk_misc_set_alignment( GTK_MISC(label), 0.0, 0.5 );
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);


		ostr << "y" << old_best_match_i << " = \"" << act_settings.func[old_best_match_i].entry << "\"" << '\0';
		label = gtk_label_new(ostr.str().c_str());
		gtk_misc_set_alignment( GTK_MISC(label), 0.05, 0.5 );
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);
		ostr.seekp(0);

		label = gtk_label_new( _("and") );
		gtk_misc_set_alignment( GTK_MISC(label), 0.0, 0.5 );
		gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, FALSE, 0);

		nr = 0;
		for(int i=0;i<10;i++)
		{
			if( act_settings.func[i].show_this  &&  i != old_best_match_i )
			{
				ostr << "y" << i << " = \"" << act_settings.func[i].entry << "\"" << '\0';

				label = gtk_label_new( ostr.str().c_str() );
				ostr.seekp(0);

				if(nr == 0)
				{
					radios[0] = gtk_radio_button_new( NULL );
					gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON(radios[0]), TRUE );
				}
				else
					radios[nr] = gtk_radio_button_new_from_widget( GTK_RADIO_BUTTON(radios[0]) );

				gtk_container_add( GTK_CONTAINER(radios[nr]), label );

				gtk_box_pack_start(GTK_BOX(vbox), radios[nr], FALSE, FALSE, 0);

				nr++;
			}
		}

		gtk_widget_show_all(dialog);

		switch(gtk_dialog_run( GTK_DIALOG(dialog) ))
		{
		case GTK_RESPONSE_OK:

			second_function = 0;
			for(int i=0;i<10;i++)
			{
				if( act_settings.func[i].show_this  &&  i != old_best_match_i )
				{
					if( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON(radios[second_function]) ) ==
						TRUE )
					{
						second_function = i;
						break;
					}
					second_function++;
				}
			}
			gtk_widget_destroy(dialog);
			break;

		default:
			gtk_widget_destroy(dialog);
			return;
		}
	}
	else // if(nr == 2)
	{
		for(int i=0;i<10;i++)
		{
			if( act_settings.func[i].show_this  &&  i != old_best_match_i )
			{
				second_function = i;
				break;
			}
		}
	}

	try
	{
		math::Variable tmpvar;

		ostr << "x = nSolve( y" << old_best_match_i << " + \" - (\" + y" << second_function
		  << " + \")\"" << ", x, ";
		str = "";
		floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
		ostr << str.c_str() << ", ";
		str = "";
		floatx_to_string( (picbild2.get_right() - picbild2.get_left()) /
		  (floatx(picbild2.pic.get_width() * 5.0)), str, stdformat);
		ostr << str.c_str() << " )" << '\0';
		if(act_settings.show_code)
		{
			(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
			(*TEXTVIEW_FUNCTION)("\n");
		}
		function.set_code_line(ostr.str().c_str());
		function.calc( 0 );
		ostr.seekp(0);



		tmp_value_x = *math::global_varlist.get_pointer(
		                       math::global_varlist.get_id("x") )->get_complex();
		function.set_code_line( act_settings.func[old_best_match_i].entry.c_str() );
		function.calc( &tmpvar );
		tmp_value_y = *tmpvar.get_complex();

		ostr << _("Intersection found at") << "\nx = ";
		str = "";
		tmp_value_x.append_to_string( str, format );

		ostr << str.c_str() << "\ny = ";
		str = "";
		tmp_value_y.append_to_string( str, format );
		ostr << str.c_str() << '\0';
		if(act_settings.show_code)
		{
			(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
			(*TEXTVIEW_FUNCTION)("\n");
		}
		place_marker( picbild2.get_float_x_pixel( floatx(tmp_value_x.real) ),
		              picbild2.get_float_y_pixel( floatx(tmp_value_y.real)),
		              act_settings.func[old_best_match_i].color );


		function.set_code_line( act_settings.func[old_best_match_i].entry.c_str() );
		function.calc( &tmpvar );
		tmp_value_y = *tmpvar.get_complex();
		place_marker( picbild2.get_float_x_pixel( floatx(tmp_value_x.real) ),
		              picbild2.get_float_y_pixel( floatx(tmp_value_y.real)),
		              act_settings.func[old_best_match_i].color );


		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO,
		                                 GTK_BUTTONS_OK, ostr.str().c_str() );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Find intersection") );
		gtk_dialog_run( GTK_DIALOG(dialog) );
		gtk_widget_destroy(dialog);
	}
	catch(error_obj error)
	{
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
		                                 GTK_BUTTONS_CLOSE, error.msg );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Find intersection") );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	catch(...)
	{
		try{ Throw_Couldnt_get_memory(); }
		catch(error_obj error)
		{
			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg);
			gtk_window_set_title( GTK_WINDOW(dialog), _("Find intersection") );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
		}
	}
}

void picwin_calc_derivate( int32 x )
{
	std::string str, str2;
	math::CodeLine function;
	GtkWidget *dialog;

	char char_str[1000];

	try
	{
		str = "";
		floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
		str2 = "";
		floatx_to_string( ((picbild2.get_x_value( x+1 )-picbild2.get_x_value( x ))/2.0), str2, stdformat);
		snprintf( char_str, 1000, "x = nDeriv( y%ld, x, %s, %s )", old_best_match_i, str.c_str(), str2.c_str() );

		function.set_code_line( char_str );
		function.calc( 0 );

		str2 = "";
		math::global_varlist.get_pointer( math::global_varlist.get_id("x") )->get_complex()->append_to_string( str2, format );

		snprintf( char_str, 1000, _("Derivate of y%ld at X=%s is\n%s"), old_best_match_i, str.c_str(), str2.c_str() );

		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO,
		                                 GTK_BUTTONS_OK, char_str );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate derivate") );
		gtk_dialog_run( GTK_DIALOG(dialog) );
		gtk_widget_destroy(dialog);
	}
	catch(error_obj error)
	{
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
		                                 GTK_BUTTONS_CLOSE, error.msg );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate derivate") );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	catch(...)
	{
		try{ Throw_Couldnt_get_memory(); }
		catch(error_obj error)
		{
			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg);
			gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate deriavte") );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
		}
	}
}

void picwin_calc_integral( int32 x )
{
	static int32 first_x;
	static int first_old_best_match_i;
	std::ostringstream ostr;
	std::string str,str2,str3;
	math::CodeLine function;
	GtkWidget *dialog;
	Complex tmp_value_x;

	char char_str[1000];

	try
	{
		if( picwin_first_click_done )
		{
			picwin_first_click_done = false;

			if( first_old_best_match_i == old_best_match_i )
			{
				ostr << "x = nInt( y" << old_best_match_i << ", x, ";
				str = "";
				floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
				ostr << str.c_str() << ", ";
				str = "";
				floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
				ostr << str.c_str() << ", " << (abs(first_x-x)*10) << " )" << '\0';

				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);

				tmp_value_x = *math::global_varlist.get_pointer(
				                       math::global_varlist.get_id("x") )->get_complex();

				ostr << "plot_picture = shade( plot_picture, y" << old_best_match_i << ", \"0\", x, ";
				str = "";
				floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
				ostr << str.c_str() << ", ";
				str = "";
				floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
				ostr << str.c_str() << ", 0"
				     << ", [[ " << act_settings.func[old_best_match_i].color.red/255.0f
				     << ", " << act_settings.func[old_best_match_i].color.green/255.0f
				     << ", " << act_settings.func[old_best_match_i].color.blue/255.0f
				     << " ]] )" << '\0';
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);
			}
			else
			{
				ostr << "x = nInt( y" << first_old_best_match_i << " + \" - ( \" + y" << old_best_match_i
				     << " + \" )\" , x, ";
				str = "";
				floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
				ostr << str.c_str() << ", ";
				str = "";
				floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
				ostr << str.c_str() << ", " << (abs(first_x-x)*10) << " )" << '\0';

				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);

				tmp_value_x = *math::global_varlist.get_pointer(
				                       math::global_varlist.get_id("x") )->get_complex();

				ostr << "plot_picture = shade( plot_picture, y" << first_old_best_match_i << ", y"
				     << old_best_match_i << ", x, ";
				str = "";
				floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
				ostr << str.c_str() << ", ";
				str = "";
				floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
				ostr << str.c_str() << ", 0"
				     << ", [[ " << act_settings.func[first_old_best_match_i].color.red/255.0f
				     << ", " << act_settings.func[first_old_best_match_i].color.green/255.0f
				     << ", " << act_settings.func[first_old_best_match_i].color.blue/255.0f
				     << " ]] )" << '\0';
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);
			}
			{
				int tmp = gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_trace) );

				function.set_code_line("show plot_picture");
				function.calc( 0 );

				gtk_widget_set_sensitive( picwin_combo_trace, TRUE );
				gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), tmp ); // auto-trace
				gtk_widget_set_sensitive( picwin_combo_action, TRUE );
				gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), LeftClickAction_CalcIntegral );
				old_best_match_i = -1;

				picbild.mousedown_func = picwin_mousedown;
			}

			str = "";  str2 = "";  str3 = "";
			floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
			floatx_to_string( picbild2.get_x_value( x ), str2, stdformat);
			tmp_value_x.append_to_string( str3, format );

			snprintf( char_str, 1000, _("Integral from %s to %s is\n%s"), str.c_str(), str2.c_str(), str3.c_str() );

			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO,
							GTK_BUTTONS_OK, char_str );
			gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate integral") );
			gtk_dialog_run( GTK_DIALOG(dialog) );
			gtk_widget_destroy(dialog);
		}
		else
		{
			first_x = x;
			first_old_best_match_i = old_best_match_i;
			picwin_first_click_done = true;

			gettimeofday( &action_combo_changed, 0 );
			gtk_label_set_text( GTK_LABEL(picwin_status), _("Select end point") );
		}
	}
	catch(error_obj error)
	{
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
		                                 GTK_BUTTONS_CLOSE, error.msg );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate integral") );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	catch(...)
	{
		try{ Throw_Couldnt_get_memory(); }
		catch(error_obj error)
		{
			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg);
			gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate integral") );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
		}
	}
}


void picwin_calc_length( int32 x )
{
	static int32 first_x;
	static int first_old_best_match_i;
	std::ostringstream ostr;
	std::string str,str2,str3;
	math::CodeLine function;
	GtkWidget *dialog;
	Complex tmp_value_x;

	char char_str[1000];

	try
	{
		if( picwin_first_click_done )
		{
			picwin_first_click_done = false;

			if( first_old_best_match_i == old_best_match_i )
			{
				ostr << "x = nInt( \"sqrt( 1.0 + nDeriv( y" << old_best_match_i << ", x, x, ";
				str = "";
				floatx_to_string( ((picbild2.get_x_value( x+1 )-picbild2.get_x_value( x ))/10.0), str, stdformat);
				ostr << str.c_str() << " ) ^2 )\", x, ";
				str = "";
				floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
				ostr << str.c_str() << ", ";
				str = "";
				floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
				ostr << str.c_str() << ", " << (abs(first_x-x)*10) << " )" << '\0';

				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );

				tmp_value_x = *math::global_varlist.get_pointer( math::global_varlist.get_id("x") )->get_complex();
			}
			else
			{
				error_obj error;
				snprintf( error.msg, ERROR_OBJ_MSG_LEN, _("Start and end point must both\nbe at the same function.") );
				throw error;
			}

			str = "";  str2 = "";  str3 = "";
			floatx_to_string( picbild2.get_x_value( first_x ), str, stdformat);
			floatx_to_string( picbild2.get_x_value( x ), str2, stdformat);
			tmp_value_x.append_to_string( str3, format );

			snprintf( char_str, 1000, _("The length of y%ld from %s to %s is\n%s"), old_best_match_i, str.c_str(),
			                                                                        str2.c_str(), str3.c_str() );

			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO,
							GTK_BUTTONS_OK, char_str );
			gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate length") );
			gtk_dialog_run( GTK_DIALOG(dialog) );
			gtk_widget_destroy(dialog);
		}
		else
		{
			first_x = x;
			first_old_best_match_i = old_best_match_i;
			picwin_first_click_done = true;

			gettimeofday( &action_combo_changed, 0 );
			gtk_label_set_text( GTK_LABEL(picwin_status), _("Select end point") );
		}
	}
	catch(error_obj error)
	{
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
		                                 GTK_BUTTONS_CLOSE, error.msg );
		gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate length") );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	catch(...)
	{
		try{ Throw_Couldnt_get_memory(); }
		catch(error_obj error)
		{
			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
			                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, error.msg);
			gtk_window_set_title( GTK_WINDOW(dialog), _("Calculate length") );
			gtk_dialog_run(GTK_DIALOG(dialog));
			gtk_widget_destroy(dialog);
		}
	}
}

void picwin_mousedown( const picture2gtk *src, int32 x, int32 y, int32 button )
{
	std::ostringstream str2;
	std::string str;
	floatx xcenter,ycenter,width,height;
	math::Variable tmpvar;

	switch(button)
	{
	case 1: // left button
		if( GTK_WIDGET_IS_SENSITIVE(picwin_combo_trace) == TRUE )
		{
			switch(gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_action) ))
			{
			case LeftClickAction_Zoom:

				xcenter = picbild2.get_x_value( x );
				ycenter = picbild2.get_y_value( y );
				width = picbild2.get_right() - picbild2.get_left();
				height = picbild2.get_top() - picbild2.get_bottom();
				width /= 4.0;
				height /= 4.0;

				try
				{
					floatx_to_string( xcenter-width, str, stdformat);
					act_settings.xmin = str.c_str();

					str = "";
					floatx_to_string( xcenter+width, str, stdformat);
					act_settings.xmax = str.c_str();

					str = "";
					floatx_to_string( ycenter-height, str, stdformat);
					act_settings.ymin = str.c_str();

					str = "";
					floatx_to_string( ycenter+height, str, stdformat);
					act_settings.ymax = str.c_str();

					{
						gint tmpint;
						tmpint = gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace));
						picturewin_show( (graph_settings *)(0) );
						gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), tmpint );
					}
				}
				catch(...) { }
				break;

			case LeftClickAction_FindRoot:
				{
					math::CodeLine function;
					std::ostringstream ostr;
					GtkWidget *dialog;
					Complex tmp_value_x,tmp_value_y;

					if( old_best_match_i == -1 )
						return;

					try
					{
						ostr << "x = nSolve( y" << old_best_match_i
						<< ", x, ";
						str = "";
						floatx_to_string( picbild2.get_x_value( x ), str, stdformat);
						ostr << str.c_str() << ", ";
						str = "";
						floatx_to_string( (picbild2.get_right() - picbild2.get_left()) /
						       (floatx(picbild2.pic.get_width()) * 5.0), str, stdformat);
						ostr << str.c_str() << " )" << '\0';
						if(act_settings.show_code)
						{
							(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
							(*TEXTVIEW_FUNCTION)("\n");
						}
						function.set_code_line(ostr.str().c_str());
						function.calc( 0 );
						ostr.seekp(0);


						str = "x = ";
						tmp_value_x = *math::global_varlist.get_pointer(
						                 math::global_varlist.get_id("x") )->get_complex();
						tmp_value_x.append_to_string( str, format );
						ostr << str.c_str() << '\0';
						if(act_settings.show_code)
						{
							(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
							(*TEXTVIEW_FUNCTION)("\n");
						}
						function.set_code_line( act_settings.func[old_best_match_i].entry.c_str() );
						function.calc( &tmpvar );
						tmp_value_y = *tmpvar.get_complex();
						place_marker( picbild2.get_float_x_pixel(
						              floatx(tmp_value_x.real) ),
						              picbild2.get_float_y_pixel( floatx(tmp_value_y.real)),
						              act_settings.func[old_best_match_i].color );


						dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
						                                 GTK_MESSAGE_INFO, GTK_BUTTONS_OK,
						                                 ostr.str().c_str() );
						gtk_window_set_title( GTK_WINDOW(dialog), _("Find root") );
						gtk_dialog_run( GTK_DIALOG(dialog) );
						gtk_widget_destroy(dialog);
					}
					catch(error_obj error)
					{
						dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
						                                 GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE,
						                                 error.msg );
						gtk_window_set_title( GTK_WINDOW(dialog), _("Find root") );
						gtk_dialog_run( GTK_DIALOG(dialog) );
						gtk_widget_destroy(dialog);
					}
					catch(...)
					{
						try{ Throw_Couldnt_get_memory(); }
						catch(error_obj error)
						{
							dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin),
							                                 GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
							                                 GTK_BUTTONS_CLOSE, error.msg );
							gtk_window_set_title( GTK_WINDOW(dialog), _("Find root") );
							gtk_dialog_run(GTK_DIALOG(dialog));
							gtk_widget_destroy(dialog);
						}
					}
				}
				break;  // LeftClickAction_FindRoot

			case LeftClickAction_FindMaximumMinimum:
				{
					math::CodeLine function;
					std::ostringstream ostr;
					GtkWidget *dialog;
					Complex tmp_value_x,tmp_value_y;

					if( old_best_match_i == -1 )
						return;

					try
					{
						ostr << "ans = \"nDeriv( y" << old_best_match_i
						<< ", x, x )\"" << '\0';
						if(act_settings.show_code)
						{
							(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
							(*TEXTVIEW_FUNCTION)("\n");
						}
						function.set_code_line(ostr.str().c_str());
						function.calc( 0 );
						ostr.seekp(0);

						ostr << "x = nSolve( ans, x, ";
						str = "";
						floatx_to_string( picbild2.get_x_value( x ), str, stdformat );
						ostr << str.c_str() << ", ";
						str= "";
						floatx_to_string( (picbild2.get_right() - picbild2.get_left()) / (floatx(picbild2.pic.get_width()) * 5.0), str, stdformat);
						ostr << str.c_str() << " )" << '\0';
						if(act_settings.show_code)
						{
							(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
							(*TEXTVIEW_FUNCTION)("\n");
						}
						function.set_code_line(ostr.str().c_str());
						function.calc( 0 );
						ostr.seekp(0);

// saves x,y for the solution
						tmp_value_x = *math::global_varlist.get_pointer( math::global_varlist.get_id("x") )->get_complex();
						function.set_code_line( act_settings.func[old_best_match_i].entry.c_str() );
						function.calc( &tmpvar );
						tmp_value_y = *tmpvar.get_complex();

						function.set_code_line( "x = nDeriv( ans, x, x )" );
						function.calc( 0 );

						if( floatx(math::global_varlist.get_pointer( math::global_varlist.get_id("x") )->get_complex()->real) > 0.0)
							ostr << _("Local minimum at");
						else
							ostr << _("Local maximum at");

						str = "\nx = ";
						tmp_value_x.append_to_string( str, format );

						ostr << str.c_str();
						str = "\ny = ";
						tmp_value_y.append_to_string( str, format );
						ostr << str.c_str() << '\0';
						if(act_settings.show_code)
						{
							(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
							(*TEXTVIEW_FUNCTION)("\n");
						}
						place_marker( picbild2.get_float_x_pixel( floatx(tmp_value_x.real) ), picbild2.get_float_y_pixel( floatx(tmp_value_y.real)),
						act_settings.func[old_best_match_i].color );

						dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
						                                 GTK_MESSAGE_INFO, GTK_BUTTONS_OK,
						                                 ostr.str().c_str() );
						gtk_window_set_title( GTK_WINDOW(dialog), _("Find maximum/minimum") );
						gtk_dialog_run( GTK_DIALOG(dialog) );
						gtk_widget_destroy(dialog);
					}
					catch(error_obj error)
					{
						dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin), GTK_DIALOG_MODAL,
						                                 GTK_MESSAGE_ERROR,
						                                 GTK_BUTTONS_CLOSE, error.msg );
						gtk_window_set_title( GTK_WINDOW(dialog), _("Find maximum/minimum") );
						gtk_dialog_run( GTK_DIALOG(dialog) );
						gtk_widget_destroy(dialog);
					}
					catch(...)
					{
						try{ Throw_Couldnt_get_memory(); }
						catch(error_obj error)
						{
							dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin),
							                                 GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR,
							                                 GTK_BUTTONS_CLOSE, error.msg );
							gtk_window_set_title( GTK_WINDOW(dialog), _("Find maximum/minimum") );
							gtk_dialog_run( GTK_DIALOG(dialog) );
							gtk_widget_destroy(dialog);
						}
					}
				}
				break; // LeftClickAction_FindMaximumMinimum

			case LeftClickAction_FindIntersection:
				if( old_best_match_i == -1 )
					return;
				picwin_intersection_show( x );
				break;

			case LeftClickAction_CalcDerivate:
				if( old_best_match_i == -1 )
					return;
				picwin_calc_derivate( x );
				break;

			case LeftClickAction_CalcIntegral:
				if( old_best_match_i == -1 )
					return;
				picwin_calc_integral( x );
				break;

			case LeftClickAction_CalcLength:
				if( old_best_match_i == -1 )
					return;
				picwin_calc_length( x );
				break;
			}
		}
		break;

	case 2: // middle button
		if(GTK_WIDGET_IS_SENSITIVE(picwin_combo_trace) == TRUE)
		{
			switch( gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace)) )
			{
			case 0: // off
				gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), 1 );
				break;

			case 1: // auto
				if(old_best_match_i != -1)
					gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace),
					                   conv_function_index_to_combobox_index(old_best_match_i) );
				break;


			default: // locked
				gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), 1 );
			}
		}
		break;

	case 3: // right button
		if(GTK_WIDGET_IS_SENSITIVE(picwin_combo_trace) == TRUE)
		{
			xcenter = picbild2.get_x_value( x );
			ycenter = picbild2.get_y_value( y );
			width = picbild2.get_right() - picbild2.get_left();
			height = picbild2.get_top() - picbild2.get_bottom();

			try
			{
				str = "";
				floatx_to_string( xcenter-width, str, stdformat);
				act_settings.xmin = str.c_str();

				str = "";
				floatx_to_string( xcenter+width, str, stdformat);
				act_settings.xmax = str.c_str();

				str = "";
				floatx_to_string( ycenter-height, str, stdformat);
				act_settings.ymin = str.c_str();

				str = "";
				floatx_to_string( ycenter+height, str, stdformat);
				act_settings.ymax = str.c_str();

				{
					gint tmpint;
					tmpint = gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace));
					picturewin_show( (graph_settings *)(0) );
					gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), tmpint );
				}
			}
			catch(...) { }
		}
		break;
	}
}




void picwin_hline( guchar *buffer, int32 width, int32 height, int32 row, picture_h::colorrgb &color)
{
	if( row < 0  ||  row >= height  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	buffer += width*3*row;
	for(;width != 0;width--)
	{
		*buffer++ = guchar(color.red);
		*buffer++ = guchar(color.green);
		*buffer++ = guchar(color.blue);
	}
}
void picwin_vline( guchar *buffer, int32 width, int32 height, int32 col, picture_h::colorrgb &color)
{
	if( col < 0  ||  col >= width  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	int rowstride = 3*width - 2;
	buffer += 3*col;
	for(;height != 0;height--, buffer += rowstride)
	{
		*buffer++ = guchar(color.red);
		*buffer++ = guchar(color.green);
		*buffer = guchar(color.blue);
	}
}

void picwin_get_row( const guchar *buffer, int32 width, int32 height, int32 row, guchar *dest)
{
	if( row < 0  ||  row >= height  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	register int32 tmp = width*3;
	buffer += tmp*row;

	memcpy(dest, buffer, tmp);
}

void picwin_set_row( guchar *buffer, int32 width, int32 height, int32 row, const guchar *src)
{
	if( row < 0  ||  row >= height  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	register int32 tmp = width*3;
	buffer += tmp*row;

	memcpy(buffer, src, tmp);
}

void picwin_get_col( const guchar *buffer, int32 width, int32 height, int32 col, guchar *dest)
{
	if( col < 0  ||  col >= width  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	int rowstride = 3*width - 2;
	buffer += 3*col;
	for(;height != 0;height--, buffer += rowstride)
	{
		*dest++ = *buffer++;
		*dest++ = *buffer++;
		*dest++ = *buffer;
	}
}

void picwin_set_col( guchar *buffer, int32 width, int32 height, int32 col, const guchar *src)
{
	if( col < 0  ||  col >= width  ||  width <= 0  ||  height <= 0  ||  buffer == 0 )
		return;

	int rowstride = 3*width - 2;
	buffer += 3*col;
	for(;height != 0;height--, buffer += rowstride)
	{
		*buffer++ = *src++;
		*buffer++ = *src++;
		*buffer = *src++;
	}
}

void picwin_remove_old_trace_mark(int32 x, int32 y)
{
	if( old_best_match_i != -1 )
	{
		int32 tx,ty;

		if( picwin_rowbuffer_len < picbild2.pic.get_width() )
		{
			delete [] picwin_rowbuffer;
			picwin_rowbuffer = 0;
			picwin_rowbuffer_len = 0;

			picwin_rowbuffer = new guchar [ picbild2.pic.get_width()*3 ];
			picwin_rowbuffer_len = picbild2.pic.get_width();
		}
		if( picwin_colbuffer_len < picbild2.pic.get_height() )
		{
			delete [] picwin_colbuffer;
			picwin_colbuffer = 0;
			picwin_colbuffer_len = 0;

			picwin_colbuffer = new guchar [ picbild2.pic.get_height()*3 ];
			picwin_colbuffer_len = picbild2.pic.get_height();
		}

		tx = picbild2.get_x_pixel( floatx(trace_matrix.get_complex( x+1, 1 ).real) );

		ty = picbild2.get_y_pixel( floatx(trace_matrix.get_complex( x+1, old_best_match_i+2 ).real) );

		picwin_set_col( picbild.get_intern_buffer(), picbild2.pic.get_width(),
		                picbild2.pic.get_height(), old_tx, picwin_colbuffer );
		picwin_set_row( picbild.get_intern_buffer(), picbild2.pic.get_width(),
		                picbild2.pic.get_height(), old_ty, picwin_rowbuffer );

		picbild.force_expose_line( old_ty );
		picbild.force_expose_col( old_tx );

		old_best_match_i = -1;
	}
}

void picwin_mousemove( const picture2gtk *src, int32 x, int32 y )
{
	const uint32 limit_tiden = 3000000;
	uint32 tiden;
	{
		timeval tmp;
		gettimeofday( &tmp ,0 );

		tiden = 1000000*(tmp.tv_sec - action_combo_changed.tv_sec) + tmp.tv_usec - action_combo_changed.tv_usec;
	}

	picwin_remove_old_trace_mark(x,y);

	if( GTK_WIDGET_IS_SENSITIVE(picwin_combo_trace) == TRUE  &&
	  gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_trace) ) == 0 ) // no trace
		gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), 0 ); // zoom

	if( x < 0  ||  x >= picbild2.pic.get_width()  ||  y < 0  ||  y >= picbild2.pic.get_height() )
	{
		if( gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_action) ) < 1 )
			gtk_label_set_text( GTK_LABEL(picwin_status), PRG_NAME );
	}
	else
	{
		static char str[100];
		Complex tmp,best_match;
		floatx y_value;
		int i, best_match_i;
		static std::ostringstream ostr;
		static std::string stri;
		Format tmp_format;
		const char *trans;

		tmp_format = format;
		tmp_format.show_trailingzeros = true;

		if( gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace)) != 0 )
		{
			if( act_settings.active_page != 0  &&  act_settings.show_active_page_only )
				goto picwin_no_trace;

			if( gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace)) == 1 )
			{
				y_value = picbild2.get_y_value( y );
				best_match_i = -1;
				for(i=0;i<10;i++) // this loop finds first (if any) non error trace
				{
					if(act_settings.func[i].show_this)
					{
						best_match_i = i;
						best_match = trace_matrix.get_complex( x+1, i+2 );
						if( floatx(best_match.imaginary) == 0.0 )
							break;
					}
				}
				if(best_match_i == -1)
					goto picwin_no_trace;
				for( i++; i<10; i++ )
				{
					if(act_settings.func[i].show_this)
					{
						tmp = trace_matrix.get_complex( x+1, i+2 );
						if(floatx(tmp.imaginary) != 0.0) // skip this
							continue;
						if( fabsx(floatx(tmp.real) - y_value) < fabsx(floatx(best_match.real) - y_value) )
						{
							best_match_i = i;
							best_match = tmp;
						}
					}
				}
			}
			else // this is a locked trace
			{
				best_match_i = conv_combobox_index_to_function_index(
				gtk_combo_box_get_active(GTK_COMBO_BOX(picwin_combo_trace)) );
				best_match = trace_matrix.get_complex( x+1, best_match_i+2 );
			}

			if(floatx(best_match.imaginary) != 0.0)
			{
				if( gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_action) ) < 1  ||  tiden > limit_tiden )
				{
					stri = "X=";
					floatx_to_string( floatx(trace_matrix.get_complex( x+1, 1 ).real), stri, tmp_format );
					ostr << stri.c_str() << "  Y=" << _("Error") << '\0';
					gtk_label_set_text( GTK_LABEL(picwin_status), ostr.str().c_str() );

					ostr.seekp(0);
				}
			}
			else
			{
				if( gtk_combo_box_get_active( GTK_COMBO_BOX(picwin_combo_action) ) < 1  ||  tiden > limit_tiden )
				{
					ostr << "y" << best_match_i << "( ";
					stri = "";
					floatx_to_string( floatx(trace_matrix.get_complex( x+1, 1 ).real), stri, tmp_format );
					ostr << stri.c_str() << " ) = ";
					stri = "";
					floatx_to_string( floatx(trace_matrix.get_complex( x+1, best_match_i+2 ).real), stri, tmp_format );
					ostr << stri.c_str() << '\0';
					gtk_label_set_text( GTK_LABEL(picwin_status), ostr.str().c_str() );
					ostr.seekp(0);
				}

				try
				{
					int32 tx,ty;

					if( picwin_rowbuffer_len < picbild2.pic.get_width() )
					{
						delete [] picwin_rowbuffer;
						picwin_rowbuffer = 0;
						picwin_rowbuffer_len = 0;

						picwin_rowbuffer = new guchar [ picbild2.pic.get_width()*3 ];
						picwin_rowbuffer_len = picbild2.pic.get_width();
					}
					if( picwin_colbuffer_len < picbild2.pic.get_height() )
					{
						delete [] picwin_colbuffer;
						picwin_colbuffer = 0;
						picwin_colbuffer_len = 0;

						picwin_colbuffer = new guchar [ picbild2.pic.get_height()*3 ];
						picwin_colbuffer_len = picbild2.pic.get_height();
					}

					tx = picbild2.get_x_pixel( floatx(trace_matrix.get_complex( x+1, 1 ).real) );

					if( tx != old_tx  ||  best_match_i != old_best_match_i )
					{
						ty = picbild2.get_y_pixel( floatx(trace_matrix.get_complex( x+1, best_match_i+2 ).real) );

						if( old_best_match_i != -1 )
						{
							picwin_set_col( picbild.get_intern_buffer(), picbild2.pic.get_width(),
											picbild2.pic.get_height(), old_tx, picwin_colbuffer );
							picwin_set_row( picbild.get_intern_buffer(), picbild2.pic.get_width(),
											picbild2.pic.get_height(), old_ty, picwin_rowbuffer );

							picbild.force_expose_line( old_ty );
							picbild.force_expose_col( old_tx );
						}
						picwin_get_row( picbild.get_intern_buffer(), picbild2.pic.get_width(),
										picbild2.pic.get_height(), ty, picwin_rowbuffer );
						picwin_get_col( picbild.get_intern_buffer(), picbild2.pic.get_width(),
										picbild2.pic.get_height(), tx, picwin_colbuffer );

						picwin_hline( picbild.get_intern_buffer(), picbild2.pic.get_width(),
									  picbild2.pic.get_height(), ty,
									  act_settings.func[best_match_i].color );
						picwin_vline( picbild.get_intern_buffer(), picbild2.pic.get_width(),
									  picbild2.pic.get_height(), tx,
									  act_settings.func[best_match_i].color );

						picbild.force_expose_line( ty );
						picbild.force_expose_col( tx );

						old_tx = tx;
						old_ty = ty;
						old_best_match_i = best_match_i;
					}
				}
				catch(error_obj error)
				{
					(*TEXTVIEW_FUNCTION)("\n\nError while updating trace: ");
					(*TEXTVIEW_FUNCTION)(error.msg);
					(*TEXTVIEW_FUNCTION)("\n\n");
				}
				catch(...)
				{
					try{ Throw_Couldnt_get_memory(); }
					catch(error_obj error)
					{
						(*TEXTVIEW_FUNCTION)("\n\nError while updating trace: ");
						(*TEXTVIEW_FUNCTION)(error.msg);
						(*TEXTVIEW_FUNCTION)("\n\n");
					}
				}
			}
		}
		else
		{
			picwin_no_trace:
			bool trailingzeros = stdformat.show_trailingzeros;
			stdformat.show_trailingzeros = true;
			stri = "X=";
			floatx_to_string( picbild2.get_x_value( x ), stri, stdformat);
			ostr << stri.c_str() << "  Y=";
			stri = "";
			floatx_to_string( picbild2.get_y_value( y ), stri, stdformat);
			ostr << stri.c_str() << '\0';
			gtk_label_set_text( GTK_LABEL(picwin_status), ostr.str().c_str() );
			ostr.seekp(0);
			stdformat.show_trailingzeros = trailingzeros;

			if( old_best_match_i != -1 )
			{
				int32 tx,ty;

				if( picwin_rowbuffer_len < picbild2.pic.get_width() )
				{
					delete [] picwin_rowbuffer;
					picwin_rowbuffer = 0;
					picwin_rowbuffer_len = 0;

					picwin_rowbuffer = new guchar [ picbild2.pic.get_width()*3 ];
					picwin_rowbuffer_len = picbild2.pic.get_width();
				}
				if( picwin_colbuffer_len < picbild2.pic.get_height() )
				{
					delete [] picwin_colbuffer;
					picwin_colbuffer = 0;
					picwin_colbuffer_len = 0;

					picwin_colbuffer = new guchar [ picbild2.pic.get_height()*3 ];
					picwin_colbuffer_len = picbild2.pic.get_height();
				}

				tx = picbild2.get_x_pixel( floatx(trace_matrix.get_complex( x+1, 1 ).real) );

				ty = picbild2.get_y_pixel( floatx(trace_matrix.get_complex( x+1, best_match_i+2 ).real) );

				picwin_set_col( picbild.get_intern_buffer(), picbild2.pic.get_width(),
								picbild2.pic.get_height(), old_tx, picwin_colbuffer );
				picwin_set_row( picbild.get_intern_buffer(), picbild2.pic.get_width(),
								picbild2.pic.get_height(), old_ty, picwin_rowbuffer );

				picbild.force_expose_line( old_ty );
				picbild.force_expose_col( old_tx );

				old_best_match_i = -1;
			}
		}
	}
}

void picwin_mousenop(const picture2gtk *src,int32 x,int32 y,int32 button) {  }

void picturewin_save_as(void)
{
	GtkWidget *file_chooser, *tmp, *tmp2, *hbox, *picwin_save_format;
	GtkFileFilter *filter;

	file_chooser = gtk_file_chooser_dialog_new( dialog_title_save_as,
	                                            GTK_WINDOW(picturewin),
	                                            GTK_FILE_CHOOSER_ACTION_SAVE,
	                                            GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
	                                            GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT,
	                                            NULL );


	filter = gtk_file_filter_new();
	gtk_file_filter_add_pattern(filter, "*.pcx");
	gtk_file_filter_add_pattern(filter, "*.ppm");
	gtk_file_filter_set_name(filter, filter_picture_files);
	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(file_chooser), filter);

	filter = gtk_file_filter_new();
	gtk_file_filter_add_pattern(filter, "*.pcx");
	gtk_file_filter_set_name(filter, filter_pcx_files);
	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(file_chooser), filter);

	filter = gtk_file_filter_new();
	gtk_file_filter_add_pattern(filter, "*.ppm");
	gtk_file_filter_set_name(filter, filter_ppm_files);
	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(file_chooser), filter);

	filter = gtk_file_filter_new();
	gtk_file_filter_add_pattern(filter, "*");
	gtk_file_filter_set_name(filter, filter_all_files);
	gtk_file_chooser_add_filter(GTK_FILE_CHOOSER(file_chooser), filter);

	hbox = gtk_hbox_new(FALSE,0);
	gtk_widget_show( hbox );

	picwin_save_format = gtk_option_menu_new();
	gtk_widget_show( picwin_save_format );

	tmp = gtk_menu_new();
	gtk_widget_show( tmp );

	tmp2 = gtk_menu_item_new_with_label( _("PCX") );
	gtk_widget_show( tmp2 );
	gtk_menu_shell_append(GTK_MENU_SHELL(tmp),tmp2);

	tmp2 = gtk_menu_item_new_with_label( _("PPM (binary)") );
	gtk_widget_show( tmp2 );
	gtk_menu_shell_append(GTK_MENU_SHELL(tmp),tmp2);

	tmp2 = gtk_menu_item_new_with_label( _("PPM (text/ascii)") );
	gtk_widget_show( tmp2 );
	gtk_menu_shell_append(GTK_MENU_SHELL(tmp),tmp2);

	gtk_option_menu_set_menu(GTK_OPTION_MENU(picwin_save_format), tmp);

	gtk_box_pack_end(GTK_BOX(hbox), picwin_save_format, FALSE, FALSE, 0);


	tmp = gtk_label_new( _("File type:") );
	gtk_widget_show( tmp );
	gtk_box_pack_end(GTK_BOX(hbox), tmp, FALSE, FALSE, 0);

	gtk_file_chooser_set_extra_widget(GTK_FILE_CHOOSER(file_chooser), hbox);

	if(gtk_dialog_run(GTK_DIALOG(file_chooser)) == GTK_RESPONSE_ACCEPT)
	{
		gint type;
		char *filename;

		filename = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(file_chooser));

		type = gtk_option_menu_get_history(GTK_OPTION_MENU(picwin_save_format));

		try
		{
			switch(type)
			{
			case 0: // PCX
				picbild2.pic.save_pcx(filename);
				break;

			case 1: // PPM (binary)
				picbild2.pic.save_ppm(filename);
				break;

			case 2: // PPM (ascii)
				picbild2.pic.save_ppm(filename,1);
				break;

			default:
				{
					error_obj error;
					error.errorcode = 47;
					snprintf(error.msg, ERROR_OBJ_MSG_LEN, "Unknown format");
					throw error;
				}
			}
		}
		catch(error_obj error)
		{
			GtkWidget *dialog;

			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin),
			                                 GTK_DIALOG_DESTROY_WITH_PARENT,
			                                 GTK_MESSAGE_ERROR,
			                                 GTK_BUTTONS_CLOSE,
			                                 error.msg );
			gtk_dialog_run( GTK_DIALOG(dialog) );
			gtk_widget_destroy(dialog);
		}
		g_free(filename);
	}
	gtk_widget_destroy(file_chooser);
}


void picturewin_show( const graph_settings *settings )
{
	enum IM_HERE { IM_HERE_picture, IM_HERE_funcion, IM_HERE_polar, IM_HERE_par };
	math::CodeLine function;
	std::ostringstream ostr;
	picture_h::colorrgb color;
	const Matrix *matr;
	IM_HERE Im_here = IM_HERE_picture;
	int i;

	old_best_match_i = -1;

	try
	{
		if(settings != 0)
			act_settings = *settings;

		ostr << "plot_picture = picture( " << act_settings.width
		     << ", " << act_settings.height
		     << ", " << act_settings.xmin
		     << ", " << act_settings.xmax
		     << ", " << act_settings.ymin
		     << ", " << act_settings.ymax
		     << ", [[ " << act_settings.bgcolor.red/255.0f
		     << ", " << act_settings.bgcolor.green/255.0f
		     << ", " << act_settings.bgcolor.blue/255.0f
		     << " ]] )" << '\0';
		if(act_settings.show_code)
		{
			(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
			(*TEXTVIEW_FUNCTION)("\n");
		}
		function.set_code_line(ostr.str().c_str());
		function.calc( 0 );  // resizing the picture
		ostr.seekp(0);

		if(act_settings.grid_on)
		{
			ostr << "plot_picture.grid( \"" << act_settings.grid_type
			     << "\", " << act_settings.grid_scale1
			     << ", " << act_settings.grid_scale2
			     << ", " << ((act_settings.use_antialiasing) ? "true" : "false")
			     << ", [[ " << act_settings.grid_color.red/255.0f
			     << ", " << act_settings.grid_color.green/255.0f
			     << ", " << act_settings.grid_color.blue/255.0f
			     << " ]] )" << '\0';
			if(act_settings.show_code)
			{
				(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
				(*TEXTVIEW_FUNCTION)("\n");
			}
			function.set_code_line(ostr.str().c_str());
			function.calc( 0 );  // adding grid
			ostr.seekp(0);
		}

		if(act_settings.axes_on)
		{
			ostr << "plot_picture.axes( " << act_settings.scalex
			     << ", " << act_settings.scaley
			     << ", " << act_settings.scale_length
			     << ", [[ " << act_settings.axes_color.red/255.0f
			     << ", " << act_settings.axes_color.green/255.0f
			     << ", " << act_settings.axes_color.blue/255.0f
			     << " ]] )" << '\0';
			if(act_settings.show_code)
			{
				(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
				(*TEXTVIEW_FUNCTION)("\n");
			}
			function.set_code_line(ostr.str().c_str());
			function.calc( 0 );  // adding axes
			ostr.seekp(0);
		}

		if(act_settings.active_page == 0  ||  act_settings.show_active_page_only == false) // function-page
		{
			Im_here = IM_HERE_funcion;
			for( i=0; i<10; i++ ) // setting up all functions
			{
				ostr << 'y' << i << " = \"" << act_settings.func[i].entry << '\"' << '\0';
				if(act_settings.show_code)
				{
					(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
					(*TEXTVIEW_FUNCTION)("\n");
				}
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);
			}
			ostr << "plot_x_matrix = table( \"x\""
			     << ", x, dec( " << act_settings.xmin
			     << " ), dec( " << act_settings.xmax
			     << " ), " << act_settings.width
			     << " )" << '\0';
			if(act_settings.show_code)
			{
				(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
				(*TEXTVIEW_FUNCTION)("\n");
			}
			function.set_code_line(ostr.str().c_str());
			function.calc( 0 ); // calculating the x list
			ostr.seekp(0);

			trace_matrix.set_size( act_settings.width, 11 );
			trace_matrix.fill( Complex( 0.0, 1.0 ) );

			matr = math::global_varlist.get_pointer( math::global_varlist.get_id("plot_x_matrix") )->get_matrix();
			for( int i2=0; i2<act_settings.width; i2++ )
				trace_matrix.set_complex(i2+1,1, matr->get_complex(i2+1,1) );

			for( i=0; i<10; i++ )
			{
				color = act_settings.func[i].color;
				if(act_settings.func[i].show_this)
				{
					ostr << "plot_y_matrix = table( y" << i
					     << ", x, dec( " << act_settings.xmin
					     << " ), dec( " << act_settings.xmax
					     << " ), " << act_settings.width
					     << ", i )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // calculating the y list
					ostr.seekp(0);

					matr = math::global_varlist.get_pointer( math::global_varlist.get_id("plot_y_matrix") )->get_matrix();
					for( int i2=0; i2<act_settings.width; i2++ )
						trace_matrix.set_complex(i2+1,i+2, matr->get_complex(i2+1,1) );

					ostr << "plot_picture.plot( plot_x_matrix, plot_y_matrix"
					     << ", \"" << act_settings.plot_mode
					     << "\", \"Dot\", 0, false"
					     << ", " << ((act_settings.use_antialiasing) ? "true" : "false")
					     << ", [[ " << color.red/255.0f
					     << ", " << color.green/255.0f
					     << ", " << color.blue/255.0f
					     << " ]] )" << '\0';

					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // drawing function
					ostr.seekp(0);
				}
			}
		}
		if(act_settings.active_page == 1  ||  act_settings.show_active_page_only == false) // polar-page
		{
			Im_here = IM_HERE_polar;
			bool connected = true;
			if( act_settings.plot_mode == "Dots" )
				connected = false;
			for( i=0; i<10; i++ ) // setting up all functions
			{
				ostr << 'r' << i << " = \"" << act_settings.polar[i].entry << '\"' << '\0';
				if(act_settings.show_code)
				{
					(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
					(*TEXTVIEW_FUNCTION)("\n");
				}
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);
			}
			for( i=0; i<10; i++ )
			{
				color = act_settings.polar[i].color;
				if(act_settings.polar[i].show_this)
				{
					ostr << "plot_x_matrix = table( \"r" << i << "(x)cos x\""
					     << ", x, " << act_settings.polar_start
					     << ", " << act_settings.polar_stop
					     << ", " << act_settings.polar_steps
					     << ", i )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // calculating the x list
					ostr.seekp(0);

					ostr << "plot_y_matrix = table( \"r" << i << "(x)sin x\""
					     << ", x, " << act_settings.polar_start
					     << ", " << act_settings.polar_stop
					     << ", " << act_settings.polar_steps
					     << ", i )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // calculating the x list
					ostr.seekp(0);

					ostr << "plot_picture.plot( plot_x_matrix, plot_y_matrix"
					     << ", \"" << ((connected)?"Connected":"Dots")
					     << "\", \"Dot\", 0, false"
					     << ", " << ((act_settings.use_antialiasing) ? "true" : "false")
					     << ", [[ " << color.red/255.0f
					     << ", " << color.green/255.0f
					     << ", " << color.blue/255.0f
					     << " ]] )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // drawing function
					ostr.seekp(0);
				}
			}
		}
		if(act_settings.active_page == 2  ||  act_settings.show_active_page_only == false) // parameter-page
		{
			Im_here = IM_HERE_par;
			bool connected = true;
			if( act_settings.plot_mode == "Dots" )
				connected = false;
			for( i=0; i<5; i++ ) // setting up all functions
			{
				ostr << "xf" << i << " = \"" << act_settings.par[i].entry << '\"' << '\0';
				if(act_settings.show_code)
				{
					(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
					(*TEXTVIEW_FUNCTION)("\n");
				}
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);

				ostr << "yf" << i << " = \"" << act_settings.par[i].entry2 << '\"' << '\0';
				if(act_settings.show_code)
				{
					(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
					(*TEXTVIEW_FUNCTION)("\n");
				}
				function.set_code_line(ostr.str().c_str());
				function.calc( 0 );
				ostr.seekp(0);
			}
			for( i=0; i<5; i++ )
			{
				color = act_settings.par[i].color;
				if(act_settings.par[i].show_this)
				{
					ostr << "plot_x_matrix = table( xf" << i
					     << ", x, " << act_settings.par_start
					     << ", " << act_settings.par_stop
					     << ", " << act_settings.par_steps
					     << ", i )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // calculating the x list
					ostr.seekp(0);

					ostr << "plot_y_matrix = table( yf" << i
					     << ", x, " << act_settings.par_start
					     << ", " << act_settings.par_stop
					     << ", " << act_settings.par_steps
					     << ", i )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // calculating the y list
					ostr.seekp(0);

					ostr << "plot_picture.plot( plot_x_matrix, plot_y_matrix"
					     << ", \"" << ((connected)?"Connected":"Dots")
					     << "\", \"Dot\", 0, false"
					     << ", " << ((act_settings.use_antialiasing) ? "true" : "false")
					     << ", [[ " << color.red/255.0f
					     << ", " << color.green/255.0f
					     << ", " << color.blue/255.0f
					     << " ]] )" << '\0';
					if(act_settings.show_code)
					{
						(*TEXTVIEW_FUNCTION)(ostr.str().c_str());
						(*TEXTVIEW_FUNCTION)("\n");
					}
					function.set_code_line(ostr.str().c_str());
					function.calc( 0 );  // drawing parameter function
					ostr.seekp(0);
				}
			}
		}
		if(act_settings.show_code)
			(*TEXTVIEW_FUNCTION)("show plot_picture\n\n");
		function.set_code_line("show plot_picture");
		function.calc( 0 );

		gtk_widget_set_sensitive( picwin_combo_trace, TRUE );
		gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), 1 ); // auto-trace
		gtk_widget_set_sensitive( picwin_combo_action, TRUE );
		gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), 0 ); // zoom
		old_best_match_i = -1;

		picbild.mousedown_func = picwin_mousedown;
	}
	catch(error_obj error)
	{
		GtkWidget *dialog;
		std::string str;
		char tkn[2];
		tkn[1] = '\0';

		switch( Im_here )
		{
		case IM_HERE_picture:
			str = "When creating plot-picture: ";
			break;
		case IM_HERE_funcion:
			str = "When plotting y";
			tkn[0] = char(i)+'0';
			str.append( tkn );
			str.append( ": " );
			break;
		case IM_HERE_polar:
			str = "When plotting r";
			tkn[0] = char(i)+'0';
			str.append( tkn );
			str.append( ": " );
			break;
		case IM_HERE_par:
			str = "When plotting xf";
			tkn[0] = char(i)+'0';
			str.append( tkn );
			str.append( " yf" );
			str.append( tkn );
			str.append( ": " );
			break;
		}

		str.append( error.msg );
		dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin),
		                                 GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR,
		                                 GTK_BUTTONS_CLOSE, str.c_str() );
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	catch(...)
	{
		try{ Throw_Couldnt_get_memory(); }
		catch(error_obj error)
		{
			GtkWidget *dialog;

			dialog = gtk_message_dialog_new( GTK_WINDOW(picturewin),
			                                 GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR,
			                                 GTK_BUTTONS_CLOSE, error.msg );
			gtk_dialog_run( GTK_DIALOG(dialog) );
			gtk_widget_destroy(dialog);
		}
	}
}

void picwin_combo_action_changed( GtkComboBox *widget, gpointer user_data )
{
	gettimeofday( &action_combo_changed, 0 );

	switch( gtk_combo_box_get_active( widget ) )
	{
	case LeftClickAction_Zoom:
		gtk_label_set_text( GTK_LABEL(picwin_status), PRG_NAME );
		break;

	case LeftClickAction_FindRoot:
	case LeftClickAction_FindMaximumMinimum:
	case LeftClickAction_FindIntersection:
		gtk_label_set_text( GTK_LABEL(picwin_status), _("Make a guess") );
		break;

	case LeftClickAction_CalcDerivate:
		gtk_label_set_text( GTK_LABEL(picwin_status), _("Select point") );
		break;
	case LeftClickAction_CalcIntegral:
	case LeftClickAction_CalcLength:
		gtk_label_set_text( GTK_LABEL(picwin_status), _("Select start point") );
		break;
	}
	picwin_first_click_done = false;
}

GtkWidget* picturewin_build_menu(void)
{
	GtkActionGroup *actions;
	GtkUIManager *ui_manager;
	GError *error = NULL;

	static const gchar *menu =
"<ui>"
"  <menubar name='MenuBar'>"
"    <menu action='FileMenu'>"
"      <menuitem action='SaveAs'/>"
"      <separator/>"
"      <menuitem action='Close'/>"
"      <separator/>"
"      <menuitem action='Quit'/>"
"    </menu>"
"  </menubar>"
"</ui>";
	GtkActionEntry entries[] = {
{ "FileMenu", NULL,              menu_file },
{ "SaveAs",   GTK_STOCK_SAVE_AS, menu_file_save_as, "<shift><ctrl>S", NULL, G_CALLBACK(picturewin_save_as) },
{ "Close",    GTK_STOCK_CLOSE,   menu_file_close,   "<ctrl>W",        NULL, G_CALLBACK(picturewin_close) },
{ "Quit",     GTK_STOCK_QUIT,    menu_file_quit,    "<ctrl>Q",        NULL, G_CALLBACK(UMP_gtk_quit) }
};
	guint n_entries = G_N_ELEMENTS(entries);

	actions = gtk_action_group_new("Actions");
	gtk_action_group_add_actions(actions, entries, n_entries, NULL);
	ui_manager = gtk_ui_manager_new();
	gtk_ui_manager_insert_action_group(ui_manager, actions, 0);
	gtk_window_add_accel_group( GTK_WINDOW(picturewin), gtk_ui_manager_get_accel_group(ui_manager) );
	if (!gtk_ui_manager_add_ui_from_string(ui_manager, menu, -1, &error))
	{
		g_message("building menus failed: %s", error->message);
		g_error_free(error);
		return 0;
	}
	gtk_ui_manager_ensure_update(ui_manager);


	return gtk_ui_manager_get_widget(ui_manager, "/MenuBar");
}

void picturewin_show( const char *title, const math::Picture &src )
{
	static int combobox_trace_last_nrofentries;
	GtkWidget *drawarea,*scrolled;

	old_best_match_i = -1;

	if(picturewin == 0)
	{
		picturewin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
		gtk_window_set_title(GTK_WINDOW(picturewin), title);
		g_signal_connect_swapped( GTK_OBJECT(picturewin), "delete-event",
		                          G_CALLBACK(picturewin_close), NULL);

		picturewin_vbox = gtk_vbox_new(FALSE,0);

		if((picturewin_menu = picturewin_build_menu()) == 0)
		{
			gtk_widget_destroy( picturewin );
			picturewin = 0;
			return;
		}
		gtk_box_pack_start(GTK_BOX(picturewin_vbox), picturewin_menu, FALSE, FALSE, 0);

		{
			GtkWidget *tbox;
			const char *trans_end;
			std::string str;

			tbox = gtk_hbox_new(FALSE,2);

			picwin_label_trace = gtk_label_new( _("Trace action") );
			gtk_box_pack_start(GTK_BOX(tbox), picwin_label_trace, FALSE, FALSE, 2 );

			picwin_combo_trace = gtk_combo_box_new_text();
			gtk_box_pack_start(GTK_BOX(tbox), picwin_combo_trace, FALSE, FALSE, 2 );
			gtk_label_set_mnemonic_widget( GTK_LABEL(picwin_label_trace), picwin_combo_trace );

			gtk_widget_set_sensitive(picwin_combo_trace, FALSE);


			picwin_combo_action = gtk_combo_box_new_text();
			gtk_box_pack_end(GTK_BOX(tbox), picwin_combo_action, FALSE, FALSE, 2 );

			combobox_trace_last_nrofentries = picwin_reload_combos( 0 );

			gtk_widget_set_sensitive(picwin_combo_action, FALSE);
			gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), -1 );
			g_signal_connect( GTK_OBJECT(picwin_combo_action), "changed",
			                  G_CALLBACK(picwin_combo_action_changed), gpointer(NULL) );

			gtk_box_pack_start(GTK_BOX(picturewin_vbox), tbox, FALSE, FALSE, 2 );
		}

		drawarea = gtk_drawing_area_new();
		picbild.connect_to_drawing_area( drawarea );

		scrolled = gtk_scrolled_window_new( NULL, NULL );
		gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW(scrolled), GTK_POLICY_AUTOMATIC,
		                                GTK_POLICY_AUTOMATIC );

		gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(scrolled), drawarea );

		gtk_box_pack_start( GTK_BOX(picturewin_vbox), scrolled, TRUE, TRUE, 0 );

		{
			GtkWidget *tbox, *tbar;
			tbox = gtk_hbox_new( FALSE, 0 );

			picwin_status = gtk_label_new( PRG_NAME );
			gtk_misc_set_alignment( GTK_MISC(picwin_status), 0.0f, 0.5f );
			gtk_box_pack_start( GTK_BOX(tbox), picwin_status, FALSE, FALSE, 0 );

			tbar = gtk_statusbar_new();
			gtk_box_pack_start( GTK_BOX(tbox), tbar, TRUE, TRUE, 0 );

			gtk_box_pack_start( GTK_BOX(picturewin_vbox), tbox, FALSE, FALSE, 0 );
		}

		gtk_container_add( GTK_CONTAINER(picturewin), picturewin_vbox );

		gtk_window_resize( GTK_WINDOW(picturewin), src.pic.get_width() + 10,
		                   src.pic.get_height() + 90 );

		gtk_widget_show_all(picturewin);
	}
	else
	{
		gtk_window_set_title( GTK_WINDOW(picturewin), title );
		gtk_window_resize( GTK_WINDOW(picturewin), src.pic.get_width() + 10,
		                   src.pic.get_height() + 90 );

		gtk_window_present( GTK_WINDOW(picturewin) );

		gtk_widget_set_sensitive(picwin_combo_trace, FALSE);
		gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_trace), 0 ); // trace off

		gtk_widget_set_sensitive(picwin_combo_action, FALSE);
		gtk_combo_box_set_active( GTK_COMBO_BOX(picwin_combo_action), -1 ); // no action

		combobox_trace_last_nrofentries = picwin_reload_combos( combobox_trace_last_nrofentries );
	}

	picbild2 = src;
	picbild.update_from( src.pic );

	picbild.mousemove_func = picwin_mousemove;
	picbild.mousedown_func = picwin_mousenop;
	picbild.mouseup_func = picwin_mousenop;
}


void picturewin_translate(void)
{
	if(picturewin != 0)
	{
		GtkWidget *new_menu;

		gtk_label_set( GTK_LABEL(picwin_label_trace), _("Trace action") );


		if(( new_menu = picturewin_build_menu()) == 0 )
			return;

		gtk_widget_destroy( picturewin_menu );
		picturewin_menu = new_menu;

		gtk_box_pack_start( GTK_BOX(picturewin_vbox), picturewin_menu, FALSE, FALSE, 0 );
		gtk_box_reorder_child( GTK_BOX(picturewin_vbox), picturewin_menu, 0 );

		picwin_reload_combos( 12 );
	}
}

void picturewin_close(void)
{
	if(picturewin != 0)
	{
		gtk_widget_destroy(picturewin);
		picturewin = 0;
	}
}
